#pragma once

#include "TipView.h"
#include "Application.h"
#include "UpdaterDocument.h"
#include "BaseWindow.h"
#include "NWindowTimer.h"
#include "NLayoutResourceLoader.h"
#include "WindowScriptletPlugin.h"
#include "CommandHelper.h"
#include "NotifyWindowHandler.h"
#include "MVC/Command/InstallUpdateCommand.h"
#include "SimpleTextShape.h"
#include "UpdaterModel.h"

namespace tipupdater
{
	TipServiceData *GetService(CComponent *pComponent);

	/**
	* @class UpdaterConfigAction
	* ShowUpdaterConfigDialogCommand  ȣؼ Ʈ â ش.
	*/
	class UpdaterConfigAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(UpdaterConfigAction)
		UpdaterConfigAction(void) {}
		~UpdaterConfigAction(void) {}

		void Execute(CComponent* pActionComponent)
		{
			NotifyWindowHandler::CreateInstance()->Cancel();
			CommandHelper::ExecuteCommand(_T("ShowUpdaterConfigDialogCommand"));
		}
	};

	/**
	* @class NotifyWindowUpgradeProgramAction
	* UpdateButton Ŭÿ Upgrade ȣ
	*/
	class NotifyWindowUpgradeProgramAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(NotifyWindowUpgradeProgramAction)
		NotifyWindowUpgradeProgramAction(void) {}
		~NotifyWindowUpgradeProgramAction(void) {}

		void Execute(CComponent* pActionComponent)
		{
			NotifyWindowHandler::CreateInstance()->Cancel();
			TipServiceData *service = GetService(pActionComponent);
			if( NULL == service )
				return;

// 			Application* application = Application::get_instance();
// 			UpdaterModel* model = dynamic_cast<UpdaterModel*>(application->GetModel());
// 			if (model)
// 			{
// 				UpdaterDocument* document = model->GetDocument();
// 				document->GetStatManager()->SetEntry(Entry::AlarmView);
// //				document->GetStatManager()->SendUpdateLog(service->GetID());
// 			}

			RunInstallUpdateCommand* command = dynamic_cast<RunInstallUpdateCommand*>(TipCommandFactory::get_instance()->CreateAction(_T("RunInstallUpdateCommand")));
 			if( NULL == command )
 			{
 				return;
 			}
 
 			command->SetService(service);
			command->SetEntry(Entry::AlarmView);
 			command->Execute();
		}
	};

	/**
	* @class NotifyWindowPostponeOneWeekAction
	* Ŭÿ  ڿ ˸  ȣ
	*/
	class NotifyWindowPostponeOneWeekAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(NotifyWindowPostponeOneWeekAction)
		NotifyWindowPostponeOneWeekAction(void) {}
		~NotifyWindowPostponeOneWeekAction(void) {}

		void Execute(CComponent* pActionComponent)
		{
			NotifyWindowHandler::CreateInstance()->Cancel();
			TipServiceData *service = GetService(pActionComponent);
			if( NULL == service )
				return;

			NotifyWindowPostponeCommand* command = dynamic_cast<NotifyWindowPostponeCommand*>(TipCommandFactory::get_instance()->CreateAction(_T("NotifyWindowPostponeCommand")));
			if( NULL == command )
			{
				return;
			}

			command->SetService(service);
			command->Execute();
		}
	};

	/**
	* @class KeepStartPageAction
	*   
	*/
	class KeepStartPageAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(KeepStartPageAction)
		KeepStartPageAction(void) {}
		~KeepStartPageAction(void) {}

		void Execute(CComponent* pActionComponent)
		{
			NotifyWindowHandler::CreateInstance()->Cancel();
			CommandHelper::ExecuteCommand(_T("KeepStartPageCommand"));
		}
	};

	/**
	* @class KeepStartPageAction
	* ⺻ ˻ 
	*/
	class KeepDefaultSearchAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(KeepDefaultSearchAction)
		KeepDefaultSearchAction(void) {}
		~KeepDefaultSearchAction(void) {}

		void Execute(CComponent* pActionComponent)
		{
			NotifyWindowHandler::CreateInstance()->Cancel();
			CommandHelper::ExecuteCommand(_T("KeepDefaultSearchCommand"));
		}
	};
	
	/**
	* @class NotifyWindowCloseAction
	* NotifyWindow Close
	*/
	class NotifyWindowCloseAction
	{
	public:
		DECLARE_PROPERTY_CONTAINER(NotifyWindowCloseAction)
		NotifyWindowCloseAction(void) {}
		~NotifyWindowCloseAction(void) {}

		void Execute(CComponent* pActionComponent)
		{
			NotifyWindowHandler::CreateInstance()->Cancel();
		}
	};

};
